#pragma once

#include "IExpIndicator.h" 
#include "ELRW_IImpl.h"
#include "IUserDllFunc.h"

struct _IInputVal_Life
{
	virtual ~_IInputVal_Life(){}
};

class CProxyInputsHolder
{
	typedef STLLight::vector<_IInputVal_Life*>		TCont;
public:
	explicit CProxyInputsHolder(IBaseStudy& _master)
		:	m_master(_master)
	{}
public:
	template<class T>
	inline T*		add(T* _ptr){m_cont.push_back(_ptr);return _ptr;}
public:
	~CProxyInputsHolder()
	{
		for(TCont::size_type i=0;i<m_cont.size();++i)
			__s_elapi_object_factory<_IInputVal_Life>::elapi_allocator_destroy(m_master,m_cont[i]);
	}
private:
	IBaseStudy&		m_master;
	TCont			m_cont;
};

class CBaseUserStudyData :
	public IInputsOwner
{
private:
	typedef STLLight::vector<_InputManage*>		TMyInputs;
	typedef STLLight::vector<_EntityManage*>	TVars;
private:
	static inline NumSimple __fp_accuracy_value(const size_t _mode)
	{
		static const NumSimple s_fp_accuracy_tbl[]=
		{
#define DEF_ENUM(name) 
#define END_DEF_ENUM(name) 
#define DEF_EVAL_INITED_1PARAM(unused1,unused2,_value)	_value ,

#include "FPCompareAccuracy.mh"

#undef	DEF_ENUM
#undef	END_DEF_ENUM
#undef	DEF_EVAL_INITED_1PARAM
			0
		};
		return s_fp_accuracy_tbl[ _mode%(sizeof(s_fp_accuracy_tbl)/sizeof(s_fp_accuracy_tbl[0])-1) ];
	}
public:
	explicit CBaseUserStudyData(IBaseStudy* _pBInd, size_t _flags)
		:	m_Master(_pBInd), m_flags(_flags), m_StdFunctions(_pBInd->GetPoolStandartFunctions()),
			m_LeagacyColorValue(false), print(_pBInd), m_epsilon(__fp_accuracy_value(2)),
			m_InputsHolder(*_pBInd), m_ctx_is_default(true)
	{}
protected:

#define DEF_ENUM(name)
#define DEF_EVAL_INITED_2PARAM(name,val,val1,val2)	inline size_t	_##name ()const{return m_LeagacyColorValue?( val1 ):( val2 ); }
#define END_DEF_ENUM(name)
#ifndef RGB
#define RGB(r,g,b)	R_G_B((r),(g),(b))
#endif
#include "ELColorEnum.mh"
#undef DEF_ENUM
#undef DEF_EVAL_INITED_2PARAM
#undef END_DEF_ENUM

protected:

	StringSimple		datetimetostring	(real_t src)const{return m_StdFunctions->datetimetostring(src);}
	StringSimple		datetostring		(real_t src)const{return m_StdFunctions->datetostring(src);}
	StringSimple		timetostring		(real_t src)const{return m_StdFunctions->timetostring(src);}
	StringSimple		el_datestr			(int dd, int mm, int yyyy)const{return m_StdFunctions->el_datestr(dd, mm, yyyy);}
	StringSimple		formatdate			(const char* format, real_t dateTime)const{return m_StdFunctions->formatdate(format, dateTime);}
	StringSimple		formattime			(const char* format, real_t dateTime)const{return m_StdFunctions->formattime(format, dateTime);}

	StringSimple		numtostr			(real_t val, size_t dig)const{return m_StdFunctions->numtostr(val, dig);}
	StringSimple		upperstr			(const char* str)const{return m_StdFunctions->upperstr(str);}
	StringSimple		lowerstr			(const char* str)const{return m_StdFunctions->lowerstr(str);}
	StringSimple		rightstr			(const char* str, size_t size)const{return m_StdFunctions->rightstr(str, size);}
	StringSimple		leftstr				(const char* str, size_t size)const{return m_StdFunctions->leftstr(str, size);}
	StringSimple		midstr				(const char* str, size_t pos, size_t size)const{return m_StdFunctions->midstr(str, pos, size);}
	StringSimple		spaces				(size_t amount)const{return m_StdFunctions->spaces(amount);}

protected:
	inline bool Greate	(const BoolSimple _lval, const BoolSimple _rval) { return _lval>_rval;  }
	inline bool Less	(const BoolSimple _lval, const BoolSimple _rval) { return _lval<_rval;  }
	inline bool Equal	(const BoolSimple _lval, const BoolSimple _rval) { return _lval==_rval; }
	inline bool NEqual	(const BoolSimple _lval, const BoolSimple _rval) { return !Equal(_lval,_rval); }
	inline bool LEqual	(const BoolSimple _lval, const BoolSimple _rval) { return Less(_lval,_rval) || Equal(_lval,_rval); }
	inline bool GEqual	(const BoolSimple _lval, const BoolSimple _rval) { return Greate(_lval,_rval) || Equal(_lval,_rval); }

	inline bool Greate	(const NumSimple _lval, const NumSimple _rval) { return _ELAPI_Numeric_Compare::greate<NumericSimple>(m_epsilon)(_lval,_rval); }
	inline bool Less	(const NumSimple _lval, const NumSimple _rval) { return _ELAPI_Numeric_Compare::less<NumericSimple>(m_epsilon)(_lval,_rval); }
	inline bool Equal	(const NumSimple _lval, const NumSimple _rval) { return _ELAPI_Numeric_Compare::equal<NumericSimple>(m_epsilon)(_lval,_rval); }
	inline bool NEqual	(const NumSimple _lval, const NumSimple _rval) { return !Equal(_lval,_rval); }
	inline bool LEqual	(const NumSimple _lval, const NumSimple _rval) { return Less(_lval,_rval) || Equal(_lval,_rval); }
	inline bool GEqual	(const NumSimple _lval, const NumSimple _rval) { return Greate(_lval,_rval) || Equal(_lval,_rval); }

	inline bool Greate	(const StringSimple& _lval, const StringSimple& _rval) { return _lval>_rval;  }
	inline bool Less	(const StringSimple& _lval, const StringSimple& _rval) { return _lval<_rval;  }
	inline bool Equal	(const StringSimple& _lval, const StringSimple& _rval) { return _lval==_rval; }
	inline bool NEqual	(const StringSimple& _lval, const StringSimple& _rval) { return !Equal(_lval,_rval); }
	inline bool LEqual	(const StringSimple& _lval, const StringSimple& _rval) { return Less(_lval,_rval) || Equal(_lval,_rval); }
	inline bool GEqual	(const StringSimple& _lval, const StringSimple& _rval) { return Greate(_lval,_rval) || Equal(_lval,_rval); }
protected:
	inline void	SetFPCompareAccuracy(const size_t _mode) { m_epsilon=__fp_accuracy_value(_mode); }
protected:
	void								ReBindInputs(const bool _bind)
	{
		m_ctx_is_default=true;

		for(size_t _i(0), _size(m_g_series.size()); _i<_size; ++_i)
			m_g_series.at(_i)->rebind(_bind);

		for(size_t _i(0), _size(m_inputs.size()); _i<_size; ++_i)
			m_inputs.at(_i)->rebind(_bind);

		for(size_t _i(0), _size(m_vars.size()); _i<_size; ++_i)
			m_vars.at(_i)->rebind(_bind);

	}
private:
	virtual void			__cdecl		push_back(_InputManage*const _input) OVERRIDE { m_inputs.push_back(_input); }
	virtual IBaseStudy&		__cdecl		get_host()const OVERRIDE { return *m_Master; }
public:
	virtual void			__cdecl		register_g_series(TVars::value_type const _input) OVERRIDE { m_g_series.push_back(_input); }
	virtual void			__cdecl		register_var(TVars::value_type const _var) OVERRIDE { m_vars.push_back(_var); }
private:
	virtual const bool&		__cdecl		ctx_is_default_prop() const OVERRIDE {return m_ctx_is_default;}
protected:
	IBaseStudy*const			m_Master;
	const size_t				m_flags;
protected:
	bool						m_LeagacyColorValue;
protected:
	NumSimple					m_epsilon;
protected:
	IStdFunctions*const			m_StdFunctions;
	CPrint_Wrap					print;
	CProxyInputsHolder			m_InputsHolder;
protected:
	TMyInputs					m_inputs;
private:
	TVars						m_g_series;
	TVars						m_vars;
public:
	bool						m_ctx_is_default;
};

struct IGlobalSeriesProxyFactory
{
	struct IGlobalSeriesProxy
	{
		virtual	IGlobalVar&		__cdecl	get_var_obj(const size_t)=0;
	};
	
	virtual IGlobalSeriesProxy&	__cdecl	CreateGVar(const size_t _gseries_id)=0;
};

class CBaseUserStudyGlobalData :
	public CBaseUserStudyData
{
	typedef CBaseUserStudyGlobalData	_MyT;
	typedef CBaseUserStudyData			inherited;
public:
	enum EGSeriesID
	{
		eGSID_None = -1,
#define _GLOBAL_SERIA_(_enum_val,_1) eGSID_##_enum_val ,
#include "global_series.mh"
#undef _GLOBAL_SERIA_
		eGSID_Count
	};
public:
	explicit CBaseUserStudyGlobalData(IBaseStudy* _pBInd, size_t _flags)
		:	inherited(_pBInd,_flags)

#define _GLOBAL_SERIA_(globName, _1) , globName ( (_pBInd->GetGSeriesFactory().CreateGVar( eGSID_##globName )) , *this )
#include "global_series.mh"
#undef _GLOBAL_SERIA_
	{}
private:
	class CGlobalVarWrap :
		public _EntityManage
	{
	private:
		typedef IGlobalSeriesProxyFactory::IGlobalSeriesProxy	TGlobalVarImpl;
	public:
		explicit CGlobalVarWrap(TGlobalVarImpl& _var, IInputsOwner& _owner)
			:	m_var(_var), m_pbinded_var(NULL), m_ctx_is_default(_owner.ctx_is_default_prop())
		{
			_owner.register_g_series(this);
		}
	public:
		IGlobalVar&					operator()(const size_t _dn=0)
		{
			return m_pbinded_var && 0==_dn && m_ctx_is_default ? *m_pbinded_var : get_var_obj(_dn);
		}
	private:
		virtual void			__cdecl		rebind(const bool _bind) OVERRIDE { m_pbinded_var = _bind ? &get_var_obj() : NULL; }
	public:
		IGlobalVar&					get_var_obj(const size_t _dn=0) { return m_var.get_var_obj(_dn); }
	private:
		TGlobalVarImpl&		m_var;
		IGlobalVar*			m_pbinded_var;
		const bool&			m_ctx_is_default;
	};
public:
	typedef CGlobalVarWrap	TGlobalVarProxy;
protected:
	#define _GLOBAL_SERIA_(globName, _1) CGlobalVarWrap globName;
	#include "global_series.mh"
	#undef _GLOBAL_SERIA_
};

#include "intrisinc_functions_decl.h"

class CBaseUserStudy :
	public CBaseUserStudyGlobalData,
	public CIntrisincsWrappers,
	private intrinsic_functions::IntrinsicCtx
{
public:
	explicit CBaseUserStudy(IBaseStudy* _pBInd, size_t _flags)
		:	CBaseUserStudyGlobalData(_pBInd,_flags), m_pStrategyEngine(NULL)
#ifdef _MSC_VER
#pragma warning (push)
#pragma warning (disable : 4355)
#endif
			,CIntrisincsWrappers(static_cast<intrinsic_functions::IntrinsicCtx&>(*this))
#ifdef _MSC_VER
#pragma warning (pop)
#endif
	{}
private:
	virtual const NumSimple&	epsilon()const OVERRIDE { return CBaseUserStudyData::m_epsilon; }
	virtual IBaseStudy&			base_study() OVERRIDE { return *CBaseUserStudyData::m_Master; }
protected:
	IStrategyOrders*			StrategyEngine()const{
		if (!m_pStrategyEngine)
			m_pStrategyEngine = CBaseUserStudyData::m_Master->GetStrategyOrdersGenerator();
		return m_pStrategyEngine;
	}
private:
	mutable IStrategyOrders*	m_pStrategyEngine;
};