#ifndef _ELRW_IIMPL_H_
#define _ELRW_IIMPL_H_

#include "ELRW_BaseTypes.h"
#include "localwindows_h.h"
#include "ELRW_StyleConsts.h"

// flags for varargs:
// t - all varargs are ints; r - all varargs are NumericSimple;
// c - all varargs are strings(const char*); l - vargs are bools

struct IStdFunctions
{
/************************************************************************/
/*             ELRW_Impl.h                                               */
/************************************************************************/
	virtual real_t		__cdecl			product						()				=0;
	virtual real_t		__cdecl			blocknumber					()				=0;
	virtual real_t		__cdecl			customerid					()				=0;
	virtual real_t		__cdecl			easylanguageversion			()				=0;
	virtual const char* __cdecl			getcdromdrive				()				=0;
	virtual void		__cdecl			filedelete					(const char* fName)=0;
	virtual void		__cdecl			fileappend					(const char* fName, const char* text)=0;
	virtual bool		__cdecl			playsound					(const char* fName)=0;
	virtual real_t		__cdecl			avglist						(size_t size, ...)	=0;//!0,1;r
	virtual real_t		__cdecl			minlist						(size_t size, ...)	=0;//!0,1;r
	virtual real_t		__cdecl			maxlist						(size_t size, ...)	=0;//!0,1;r
	virtual real_t		__cdecl			nthminlist					(size_t size, size_t n, ...)=0;//!1,1;r
	virtual real_t		__cdecl			nthmaxlist					(size_t size, size_t n, ...)=0;//!1,1;r
	virtual real_t		__cdecl			minlist2					(size_t size, ...)	=0;//!0,1;r
	virtual real_t		__cdecl			maxlist2					(size_t size, ...)	=0;//!0,1;r
	virtual real_t		__cdecl			sumlist						(size_t size, ...)	=0;//!0,1;r
	virtual real_t		__cdecl			squareroot					(real_t val)		=0;
	virtual real_t		__cdecl			square						(real_t val)		=0;
	virtual real_t		__cdecl			power						(real_t val, real_t power)=0;
	virtual real_t		__cdecl			expvalue					(real_t val)		=0;
	virtual real_t		__cdecl			Log							(real_t val)		=0;
	virtual real_t		__cdecl			round						(real_t val, size_t prec)=0;
	virtual real_t		__cdecl			intportion					(real_t val)		=0;
	virtual real_t		__cdecl			fracportion					(real_t val)		=0;
	virtual real_t		__cdecl			ceiling						(real_t val)		=0;
	virtual real_t		__cdecl			Floor						(real_t val)		=0;
	virtual real_t		__cdecl			tangent						(real_t val)		=0;
	virtual real_t		__cdecl			cotangent					(real_t val)		=0;
	virtual real_t		__cdecl			arctangent					(real_t val)		=0;
	virtual real_t		__cdecl			sine						(real_t val)		=0;
	virtual real_t		__cdecl			cosine						(real_t val)		=0;
	virtual real_t		__cdecl			mod							(real_t val, real_t divisor)=0;
	virtual real_t		__cdecl			neg							(real_t val)		=0;
	virtual real_t		__cdecl			pos							(real_t val)		=0;
	virtual real_t		__cdecl			random						(real_t val)		=0;
	virtual real_t		__cdecl			sign						(real_t val)		=0;
	virtual real_t		__cdecl			absvalue					(real_t val)		=0;
	virtual real_t		__cdecl			reciprocal					(real_t val)		=0;
	virtual real_t 		__cdecl			datetojulian				(int date)	=0;//!1,0;w
	virtual real_t 		__cdecl			juliantodate				(int date)	=0;
	virtual real_t 		__cdecl			stringtodatetime			(const char* src)=0;
	virtual real_t 		__cdecl			stringtodate				(const char* src)=0;
	virtual real_t 		__cdecl			stringtotime				(const char* src)=0;
	virtual const char* __cdecl			datetimetostring			(real_t src)	=0;
	virtual const char* __cdecl			datetostring				(real_t src)	=0;
	virtual const char* __cdecl			timetostring				(real_t src)	=0;
	virtual real_t 		__cdecl			year						(int date)	=0;
	virtual real_t 		__cdecl			month						(int date)	=0;
	virtual real_t 		__cdecl			dayofmonth					(int date)	=0;
	virtual real_t 		__cdecl			dayofweek					(int date)	=0;
	virtual real_t 		__cdecl			currentdate					()			=0;
	virtual real_t 		__cdecl			currenttime					()			=0;
	virtual real_t 		__cdecl			currenttime_s				()			=0;
	virtual real_t 		__cdecl			computerdatetime			()			=0;
	virtual const char* __cdecl			el_datestr					(int dd, int mm, int yyyy)=0;
	virtual real_t 		__cdecl			el_datetodatetime			(int date)=0;
	virtual real_t 		__cdecl			el_timetodatetime			(int time)=0;
	virtual real_t 		__cdecl			el_timetodatetime_s			(int time)=0;
	virtual real_t 		__cdecl			encodedate					(int yyy, int mm, int dd)=0;
	virtual real_t 		__cdecl			encodetime					(int hrs, int min, int sec, int msec)=0;
	virtual const char* __cdecl			formatdate					(const char* format, real_t dateTime)=0;
	virtual const char* __cdecl			formattime					(const char* format, real_t dateTime)=0;
	virtual real_t 		__cdecl			yearfromdatetime			(real_t dateTime)=0;
	virtual real_t 		__cdecl			monthfromdatetime			(real_t dateTime)=0;
	virtual int 		__cdecl			dayfromdatetime				(real_t dateTime)=0;
	virtual real_t 		__cdecl			dayofweekfromdatetime		(real_t dateTime)=0;
	virtual real_t 		__cdecl			hoursfromdatetime			(real_t dateTime)=0;
	virtual real_t 		__cdecl			minutesfromdatetime			(real_t dateTime)=0;
	virtual real_t 		__cdecl			secondsfromdatetime			(real_t dateTime)=0;
	virtual real_t 		__cdecl			millisecondsfromdatetime	(real_t dateTime)=0;
	virtual real_t 		__cdecl			incmonth					(real_t dateTime, int months)=0;
	virtual const char* __cdecl			numtostr					(real_t val, size_t dig)=0;
	virtual real_t 		__cdecl			strtonum					(const char* str)=0;
	virtual const char* __cdecl			upperstr					(const char* str)=0;
	virtual const char* __cdecl			lowerstr					(const char* str)=0;
	virtual const char* __cdecl			rightstr					(const char* str, size_t size)=0;
	virtual const char* __cdecl			leftstr						(const char* str, size_t size)=0;
	virtual const char* __cdecl			midstr						(const char* str, size_t pos, size_t size)=0;
	virtual size_t 		__cdecl			Strlen						(const char* str)=0;
	virtual size_t 		__cdecl			instr						(const char* where, const char* who)=0;
	virtual const char* __cdecl			spaces						(size_t amount)	=0;
	virtual const char* __cdecl			newline						()				=0;

	virtual int			__cdecl			inner_tl_new				(int sdate, int stime, real_t svalue, int edate, int etime, real_t evalue, int _dataN, bool _real_dn)=0; // INSIDEn
	virtual int			__cdecl			mc_inner_tl_new				(int sdate, int stime, real_t svalue, int edate, int etime, real_t evalue, int _dataN, bool _real_dn)=0; // INSIDEn
	virtual real_t		__cdecl			inner_tl_setbegin			(size_t ref, long date, long time, real_t& value)=0; // INSIDEn
	virtual real_t		__cdecl			inner_tl_setend			(size_t ref, long date, long time, real_t& value)=0; // INSIDEn
	virtual void		__cdecl			inner_tl_getbegin			(size_t _ref, int& date, int& time, real_t& price)=0; // INSIDEn
	virtual void		__cdecl			inner_tl_getend			(size_t _ref, int& date, int& time, real_t& price)=0; // INSIDEn
	virtual real_t		__cdecl			inner_tl_getvalue			(size_t ref, int date, int& time)=0; // INSIDEn

	virtual real_t		__cdecl			tl_setextleft				(size_t   tl_ref, BoolSimple tfExt)=0;//!2,0;i
	virtual real_t		__cdecl			tl_setextright				(size_t   tl_ref, BoolSimple tfExt)=0;//!2,0;i
	virtual long		__cdecl			tl_getfirst					(int pref)=0;//!1,0;i
	virtual long		__cdecl			tl_getnext					(size_t   tl_ref,int   pref)=0;//!2,0;i
	virtual long		__cdecl			tl_new						(long sdate, long stime, real_t svalue, long edate, long etime, real_t evalue, size_t _dataN=0)=0;//!6,0;d
	virtual long		__cdecl			mc_tl_new					(long sdate, long stime, real_t svalue, long edate, long etime, real_t evalue, size_t _dataN=0)=0;//!6,0;d
	virtual real_t		__cdecl			tl_setbegin					(size_t   ref, long date, long time, real_t value)=0;//!4,0;i
	virtual real_t		__cdecl			tl_setcolor					(size_t  ref, long color)=0;//!2,0;i
	virtual real_t		__cdecl			tl_setend					(size_t   ref, long date, long time, real_t value)=0;//!4,0;i
	virtual long		__cdecl			tl_getcolor					(size_t  ref)=0;//!1,0;i
	virtual long 		__cdecl			tl_setstyle					(size_t  ref, int style)=0;//!2,0;i
	virtual long 		__cdecl			tl_getstyle					(size_t ref)=0;//!1,0;i
	virtual long		__cdecl			tl_getactive				()		 =0;//!1,0;i
	virtual long		__cdecl			mc_tl_getactive				()		 =0;//!1,0;i
	virtual long		__cdecl			tl_getbegindate				(size_t ref)=0;//!1,0;i
	virtual long		__cdecl			tl_getbegintime				(size_t ref)=0;//!1,0;i
	virtual real_t		__cdecl			tl_getbeginval				(size_t ref)=0;//!1,0;i
	virtual long		__cdecl			tl_getenddate				(size_t ref)=0;//!1,0;i
	virtual long 		__cdecl			tl_getendtime				(size_t ref)=0;//!1,0;i
	virtual real_t		__cdecl			tl_getendval				(size_t ref)=0;//!1,0;i
	virtual long		__cdecl			tl_delete					(size_t  ref)=0;//!1,0;i
	virtual real_t		__cdecl			tl_getvalue					(size_t   ref, long date, long time)=0;
	virtual long		__cdecl			tl_setsize					(size_t   ref, long size)=0;
	virtual long		__cdecl			tl_getsize					(size_t   ref)=0;
	virtual BoolSimple	__cdecl			tl_getextleft				(size_t   ref)=0;
	virtual BoolSimple	__cdecl			tl_getextright				(size_t   ref)=0;
	virtual long		__cdecl			tl_setalert					(size_t   ref, long val)=0;
	virtual long		__cdecl			tl_getalert					(size_t   ref)=0;

	virtual long		__cdecl			tl_new_s					(long sdate, long stime, real_t svalue, long edate, long etime, real_t evalue, size_t _dataN=0)=0;//!6,0;d
	virtual long		__cdecl			mc_tl_new_s					(long sdate, long stime, real_t svalue, long edate, long etime, real_t evalue, size_t _dataN=0)=0;//!6,0;d
	virtual real_t		__cdecl			tl_setbegin_s				(size_t   ref, long date, long time, real_t value)=0;
	virtual real_t		__cdecl			tl_setend_s					(size_t   ref, long date, long time, real_t value)=0;
	virtual long		__cdecl			tl_getbegintime_s			(size_t ref)=0;//!1,0;i
	virtual long 		__cdecl			tl_getendtime_s				(size_t ref)=0;//!1,0;i
	virtual real_t		__cdecl			tl_getvalue_s				(size_t   ref, long date, long time)=0;//!3,0;i

	virtual long		__cdecl			tl_new_self_s				(/*long _magic_val, */long sdate, long stime, real_t svalue, long edate, long etime, real_t evalue)=0;
	virtual long		__cdecl			mc_tl_new_self_s			(/*long _magic_val, */long sdate, long stime, real_t svalue, long edate, long etime, real_t evalue)=0;
	virtual long		__cdecl			tl_new_self					(/*long _magic_val, */long sdate, long stime, real_t svalue, long edate, long etime, real_t evalue)=0;
	virtual long		__cdecl			mc_tl_new_self				(/*long _magic_val, */long sdate, long stime, real_t svalue, long edate, long etime, real_t evalue)=0;

	virtual int			__cdecl			inner_text_new				(int date, int time, real_t price, const char* s, int _dataN, bool _real_dn)=0; // INSIDEn
	virtual void		__cdecl			inner_text_get_location		(size_t _ref, int& date, int& time, real_t& price)=0; // INSIDEn
	virtual void		__cdecl			inner_text_set_location		(size_t _ref, const int date, const int time, const real_t& price)=0; // INSIDEn

	virtual long		__cdecl			text_new					(long date, long time, real_t price, const char* s, size_t _dataN=0)=0;//!4,0;d
	virtual long		__cdecl			text_setcolor				(size_t  ref, long color)=0;
	virtual long		__cdecl			text_setlocation			(size_t  ref, long date, long time, real_t price)=0;  
	virtual long		__cdecl			text_setstring				(size_t ref, const char* s)=0;
	virtual long 		__cdecl			text_setstyle				(size_t ref, long hor, long vert)=0;
	virtual long 		__cdecl			text_delete					(size_t ref)=0;
	virtual long		__cdecl			text_getactive				()=0;
	virtual long		__cdecl			mc_text_getactive			()=0;
	virtual long		__cdecl			text_getcolor				(size_t ref)=0;
	virtual real_t		__cdecl			text_getvalue				(size_t ref)=0;
	virtual long		__cdecl			text_getdate				(size_t ref)=0;
	virtual long		__cdecl			text_getfirst				(size_t type)=0;
	virtual long		__cdecl			text_gethstyle				(size_t ref)=0;
	virtual long 		__cdecl			text_getvstyle				(size_t ref)=0;
	virtual long		__cdecl			text_getnext				(size_t ref, long type)=0;
	virtual const char* __cdecl			text_getstring				(size_t ref)=0;
	virtual long 		__cdecl			text_gettime				(size_t ref)=0;
	virtual long 		__cdecl			text_getbgcolor				(size_t ref)=0;
	virtual long 		__cdecl			text_setbgcolor				(size_t ref, long color)=0;

	virtual long 		__cdecl			text_setsize				(size_t ref, long lSize) = 0;
	virtual long 		__cdecl			text_getsize				(size_t ref) = 0;
	virtual long 		__cdecl			text_setborder				(size_t ref, BoolSimple bFrame) = 0;
	virtual BoolSimple	__cdecl			text_getborder				(size_t ref) = 0;

	virtual long		__cdecl			text_new_s					(long date, long time, real_t price, const char* s, size_t _dataN=0)=0;//!4,0;d
	virtual long		__cdecl			text_setlocation_s			(size_t  ref, long date, long time, real_t price)=0;  
	virtual long 		__cdecl			text_gettime_s				(size_t ref)=0;

	virtual long		__cdecl			text_setattribute			(size_t ref, long _attr_type, BoolSimple _val)=0;
	virtual BoolSimple	__cdecl			text_getattribute			(size_t ref, long _attr_type)=0;
	virtual long		__cdecl			text_setfontname			(size_t ref, const char* _name)=0;
	virtual const char*	__cdecl			text_getfontname			(size_t ref)=0;

	virtual long		__cdecl			text_new_self				(/*long _magic_val, */long date, long time, real_t price, const char* s)=0;
	virtual long		__cdecl			text_new_self_s				(/*long _magic_val, */long date, long time, real_t price, const char* s)=0;

	virtual int			__cdecl			inner_arw_new				(int sdate, int stime, real_t svalue, BoolSimple lDir, int _dataN, bool _real_dn)=0; // INSIDEn
	virtual void		__cdecl			inner_arw_get_location		(size_t _ref, int& date, int& time, real_t& price)=0; // INSIDEn
	virtual void		__cdecl			inner_arw_set_location		(size_t _ref, const int date, const int time, const real_t& price)=0; // INSIDEn

	virtual long 		__cdecl			arw_new						(long sdate, long stime, real_t svalue, BoolSimple lDir, size_t _dataN=0)=0;//!4,0;d
	virtual long 		__cdecl			arw_delete					(long ref) = 0;
	virtual long 		__cdecl			arw_getactive				()	= 0;
	virtual long 		__cdecl			mc_arw_getactive			()	= 0;
	virtual long 		__cdecl			arw_getcolor				(long ref) = 0;
	virtual long 		__cdecl			arw_getdate					(long ref) = 0;
	virtual long 		__cdecl			arw_gettime					(long ref) = 0;
	virtual real_t 		__cdecl			arw_getval					(long ref) = 0;
	virtual long 		__cdecl			arw_getfirst				(size_t type) = 0;
	virtual long 		__cdecl			arw_getnext					(long arr_ref,size_t type) = 0;
	virtual BoolSimple 	__cdecl			arw_getdirection			(long ref) = 0;	// EArrowDirection
	virtual long 		__cdecl			arw_getstyle				(long ref) = 0;
	virtual long 		__cdecl			arw_getsize					(long ref) = 0;
	virtual long 		__cdecl			arw_setcolor				(long ref, long color) = 0;
	virtual long 		__cdecl			arw_setlocation				(long ref, long date, long time, real_t value) = 0;
	virtual long 		__cdecl			arw_setstyle				(long ref, long lVal) = 0;
	virtual long 		__cdecl			arw_setsize					(long ref, long lVal) = 0;
	virtual long 		__cdecl			arw_settext					(long ref, const char* _txt) = 0;
	virtual const char* __cdecl			arw_gettext					(size_t ref)=0;
	virtual long 		__cdecl			arw_settextcolor			(size_t ref, long color)=0;
	virtual long 		__cdecl			arw_gettextcolor			(size_t ref)=0;
	virtual long 		__cdecl			arw_gettextbgcolor			(size_t ref)=0;
	virtual long 		__cdecl			arw_settextbgcolor			(long ref, long _color) = 0;

	virtual long 		__cdecl			arw_new_s					(long sdate, long stime, real_t svalue, BoolSimple lDir, size_t _dataN=0)=0;//!4,0;d
	virtual long 		__cdecl			arw_gettime_s				(long ref) = 0;
	virtual long 		__cdecl			arw_setlocation_s			(long ref, long date, long time, real_t value) = 0;

	virtual long		__cdecl			arw_settextattribute		(size_t ref, long _attr_type, BoolSimple _val)=0;
	virtual BoolSimple	__cdecl			arw_gettextattribute		(size_t ref, long _attr_type)=0;
	virtual long		__cdecl			arw_settextfontname			(size_t ref, const char* _name)=0;
	virtual const char*	__cdecl			arw_gettextfontname			(size_t ref)=0;

	virtual long		__cdecl			arw_settextsize				(size_t ref, long _val)=0;
	virtual long		__cdecl			arw_gettextsize				(size_t ref)=0;

	virtual long 		__cdecl			arw_new_self				(long sdate, long stime, real_t svalue, BoolSimple lDir)=0;
	virtual long 		__cdecl			arw_new_self_s				(long sdate, long stime, real_t svalue, BoolSimple lDir)=0;

	virtual real_t		__cdecl			ab_averageprice				(real_t side)=0;//!1,0;w
	virtual real_t		__cdecl			ab_cellcount				(real_t side)=0;//!1,0;w
	virtual real_t 		__cdecl			ab_high						()=0;//!0,0;w
	virtual real_t 		__cdecl			ab_low						()=0;//!0,0;w
	virtual real_t		__cdecl			ab_rowheight				()=0;//!0,0;w
	virtual real_t 		__cdecl			rightside					()=0;//!0,0;w
	virtual real_t 		__cdecl			leftside					()=0;//!0,0;w

	virtual BoolSimple 	__cdecl			commentaryenabled			()=0;//!0,0;w
	virtual BoolSimple 	__cdecl			checkcommentary				()=0;
	virtual void 		__cdecl			ab_addcell					(real_t price, int side, const char* str, int color, real_t value)=0;//!5,0;w
	virtual int  		__cdecl			ab_getnumcells				(real_t price, int side)=0;//!2,0;w
	virtual BoolSimple 	__cdecl			atcommentarybar				()=0;
	virtual void 		__cdecl			cleardebug					()=0;
	virtual void 		__cdecl			ClearPrintLog 				()=0;
	virtual long 		__cdecl			LegacyColorToRGB			(long a)=0;
	virtual long 		__cdecl			RGBToLegacyColor			(long a)=0;
	virtual long		__cdecl			gradientcolor				(NumSimple a1,NumSimple a2, NumSimple a3, long a4, long a5)=0;//!5,0;

	virtual long		__cdecl			getrvalue					(long a)=0;
	virtual long		__cdecl			getgvalue					(long a)=0;
	virtual long		__cdecl			getbvalue					(long a)=0;
	virtual long		__cdecl			rgb							(long a1, long a2, long a3)=0;
	virtual const char*	__cdecl			doublequote					()=0;
	virtual real_t 		__cdecl			eldatetodatetime			(int date)=0;
	virtual real_t 		__cdecl			eltimetodatetime			(int time)=0;
	virtual real_t 		__cdecl			eltimetodatetime_s			(int time)=0;
	virtual long 		__cdecl			time2time_s					(long time)=0;
	virtual long 		__cdecl			time_s2time					(long time)=0;
	virtual real_t 		__cdecl			getuserid					()=0;

	virtual long 		__cdecl			datetime2eltime				(real_t _datetime)=0;
	virtual long 		__cdecl			datetime2eltime_s			(real_t _datetime)=0;

	virtual const char*	__cdecl			getcountry					()=0;
	virtual const char*	__cdecl			getcurrency					()=0;

	virtual long		__cdecl			fine						()=0;
	virtual long		__cdecl			coarse						()=0;
	virtual long		__cdecl			medium						()=0;

	virtual const char*	__cdecl			getscreenname				()=0;

	virtual void 		__cdecl			sdecommentary				()=0;
};

#endif