#pragma once

#include "VariableInterfaces.h"

struct IFunctionBase : public IUserStudyVarHost
{
	// if have been set this pointers (no NULL values) (expressions as a params one or both parts of CTX)
	// then will been used this objects for getting CTX of run
	virtual _InputVal<size_t>*&		__cdecl		ctx_dataN()=0;
	virtual _InputVal<real_t>*&		__cdecl		ctx_bb()=0;
	// else will been used literal values :
	virtual size_t&					__cdecl		ctx_dataN_const()=0;
	virtual real_t&					__cdecl		ctx_bb_const()=0;

	// binding of arguments
	virtual void*&					__cdecl		operator[](size_t)=0;
	// make real binding arguments for called functions from this class
	virtual	void					__cdecl		BindInputs()=0;
	virtual	void					__cdecl		Initialize()=0;
	virtual	void					__cdecl		DelayInitEnviroment(const size_t)=0;
	virtual	void					__cdecl		ReBindInputs(const bool)=0;
	virtual	void					__cdecl		SetCtxByDataNIsMyOrConst(const bool _data_ctx_is_const)=0;
protected:
	// !!! This method must been implemented in class of real function !!!
	// will been included the body of function
	virtual	void					__cdecl		Body()=0;
public:
	// for check run - bb (will be 0) and dataN; dataN - always normalized
	virtual void					__cdecl		fake_run(size_t)=0;
	virtual void					__cdecl		CloseBarFunc(size_t){}
public:
	virtual	_InputValInfo*			__cdecl		access_influence_for_input(const size_t _idx)=0;
	virtual	_InputValInfo*			__cdecl		access_bb()=0;
	virtual	_InputValInfo*			__cdecl		access_dn()=0;
protected:
	IFunctionBase(){}
public:
	// hold the function handler pointer for this instance for quick access to it.
	// !!!Don't initialize this field in this ctor!!! - it have been filled before IFunctionBase::ctor call!
	void*	func_descriptor;
};

template<typename T>
struct IFunction : public IFunctionBase
{
	typedef	T&					_Result;
	typedef	T					_Value;
	typedef IFunction<T>		_MyT;

	virtual _Result				__cdecl		operator()(real_t=0)=0;
	virtual						__cdecl		operator _InputVal<_Value>&()=0;
	virtual						__cdecl		operator IInputsOwner&()=0;
	//	virtual	void				__cdecl		push_influence_input(const size_t _idx)=0;
};
