#ifndef _IUserDllFunc_H_
#define _IUserDllFunc_H_

#include "IExpIndicator.h"

class CBaseUserStudyData;
typedef const CBaseUserStudyData*	TCommonBaseID;

class UserDllAbstractFunc;

#pragma pack(push,ALGN,1)
struct SEventsInfo
{
	SEventsInfo(const size_t _sn_oncerate, const size_t _sn_ondestroy)
		:create_seq_numbers(_sn_oncerate),
		destroy_seq_numbers(_sn_ondestroy)
	{}

	const size_t	create_seq_numbers;
	const size_t	destroy_seq_numbers;
};
#pragma pack(pop,ALGN)

class IDllToolKit
{
public:
	virtual	void	__stdcall	LoadFunc(TCommonBaseID,const char*,const char*,UserDllAbstractFunc*,const SEventsInfo&)=0;
	virtual	void	__stdcall	GoOnCreate(TCommonBaseID)=0;
	virtual	void*	__stdcall	GetObject(UserDllAbstractFunc*)=0;
	virtual	void	__stdcall	EnterCallDllFunction(UserDllAbstractFunc*,real_t,size_t)=0;
	virtual	void	__stdcall	LeaveCallDllFunction(UserDllAbstractFunc*)=0;
};

namespace
{
#pragma pack(push,ALGN,1)

	template<typename TStub, typename TType>
	struct _PtrParamStubImpl
	{
		explicit _PtrParamStubImpl(
			TType*const ptr, const bool _is_price,
			IBaseStudy*const _pDllMaster, const bool _is_raw_ptr
		)
			:	el_ptr(ptr), cpp_stub(*ptr), is_price(_is_price), is_raw_ptr(_is_raw_ptr)
		{
			if (is_price && !is_raw_ptr)
				cpp_stub *= (TStub)_pDllMaster->pricescale();
		}
	public:
		~_PtrParamStubImpl(){
			if (!is_price && !is_raw_ptr)
				*el_ptr = cpp_stub;
		}
	public:
		TStub* operator&(){return is_raw_ptr ? (TStub*)(void*)el_ptr : &cpp_stub;}
	private:
		TType*const	el_ptr;
		TStub		cpp_stub;
		const bool	is_price;
		const bool	is_raw_ptr;
	};

	template<typename TStub>
	struct _PtrParamStub :
		public _PtrParamStubImpl<TStub, NumSimple>
	{
		typedef	_PtrParamStubImpl<TStub, NumSimple>	inherited;
		explicit _PtrParamStub(
			NumSimple*const ptr, const bool _is_price,
			IBaseStudy*const _pDllMaster, const bool _is_raw_ptr = false
		)
			:	inherited(ptr, _is_price, _pDllMaster, _is_raw_ptr)
		{}
	};

	template<>
	struct _PtrParamStub<bool> :
		public _PtrParamStubImpl<bool, BoolSimple>
	{
		typedef	_PtrParamStubImpl<bool, BoolSimple>	inherited;
		explicit _PtrParamStub(
			BoolSimple*const ptr, const bool,
			IBaseStudy*const _pDllMaster, const bool _is_raw_ptr = false
		)
			:	inherited(ptr, false, _pDllMaster, _is_raw_ptr)
		{}
	};

	static const int __dummy=
		sizeof(_PtrParamStub<double>)+
		sizeof(_PtrParamStub<float>)+
		sizeof(_PtrParamStub<long>)+
		sizeof(_PtrParamStub<unsigned long>)+
		sizeof(_PtrParamStub<short>)+
		sizeof(_PtrParamStub<unsigned short>)+
		sizeof(_PtrParamStub<char>)+
		sizeof(_PtrParamStub<unsigned char>)+
		sizeof(_PtrParamStub<bool>)+
		sizeof(_PtrParamStub<int>)+
		sizeof(_PtrParamStub<unsigned int>);

#pragma pack(pop,ALGN)
};

class UserDllAbstractFunc 
{
protected:
	class CLocker
	{
	public:
		explicit CLocker(UserDllAbstractFunc*const _m):m_m(*_m)
		{
			m_m.m_pDllMaster->GetDllToolKit()->EnterCallDllFunction(&m_m,m_m.m_BB,m_m.m_BaseDataStream);
		}
		~CLocker()
		{
			m_m.m_pDllMaster->GetDllToolKit()->LeaveCallDllFunction(&m_m);
		}
	private:
		UserDllAbstractFunc&	m_m;
	};
	friend class CLocker;

protected:
	IBaseStudy*			m_pDllMaster;
private:
	size_t				m_BaseDataStream;
	real_t				m_BB;
protected:
	explicit UserDllAbstractFunc()
		:m_pDllMaster(NULL),m_BaseDataStream(0),m_BB(0)
	{}
public:
	inline void Initialize(	TCommonBaseID _study_id, IBaseStudy* _pMaster, const char* dllname, 
							const char* funcname, const SEventsInfo& _evinfo)
	{
		m_pDllMaster=_pMaster;
		m_pDllMaster->GetDllToolKit()->LoadFunc(_study_id,dllname,funcname,this,_evinfo);
	}
protected:
	inline void* _PFunc(){return m_pDllMaster->GetDllToolKit()->GetObject(this);}
	inline void _SetDataStream(const size_t ds) { m_BaseDataStream=ds; }
	inline void _SetBarsBack(const real_t bb) { m_BB=bb; }
};

#endif