#pragma once
#ifndef PRINT_INFO
#define PRINT_INFO

#include "ELRW_BaseTypes.h"
#include <stdarg.h>

#define  DEFAULT_WIDTH	7
#define  DEFAULT_PREC	2

struct SPrintInfo
{
	int mEasyType;
	int mWidth;
	int mPrec;

	SPrintInfo()
		:mEasyType(0),mWidth(DEFAULT_WIDTH),mPrec(DEFAULT_PREC)
	{}

	SPrintInfo(int EasyType, int Width=DEFAULT_WIDTH, int Prec=DEFAULT_PREC)
		:mEasyType(EasyType),mWidth(Width),mPrec(Prec)
	{}
};


inline const char* file(const StringSimple& f){return f.c_str();}


struct iprint_func
{
	virtual const SPrintInfo*	__stdcall	Get(size_t)const=0;
	virtual size_t				__stdcall	GetCount()const=0;
};

#include "vector_Light.h"

class print_func : public iprint_func
{
	STLLight::vector<SPrintInfo>	m_allParams;
public:
	print_func(size_t size ...)
	{
		va_list marker;
		va_start(marker,size);
		for(size_t i=0; i<size; i++) m_allParams.push_back( *(va_arg(marker,SPrintInfo*)) );
	}
	const SPrintInfo*	__stdcall	Get(size_t index)const{ return &(m_allParams[index]); }
	size_t				__stdcall	GetCount()const{ return m_allParams.size(); }
};


#endif