#pragma once

#pragma warning (disable : 4355 4267 4244 4481 4238 4127 4100)

#include "IExpIndicator.h"
#include "AbstractFunction.h"
#include "Variable.h"
#include "BaseUserStudy.h"

#include "EL_API_Version.h"

#if defined(_MSC_VER) || defined(_BCB_VER)
#include "DefValues.h"
#endif

using namespace ELRW;

class CUserIndicator : 
	public IUserBaseStudy, 
	public CBaseUserStudy
{
protected:
	IPlot*const		m_pPlots;
public:
	explicit CUserIndicator(IBaseStudy* _pBI, size_t _flags)
		:	CBaseUserStudy(_pBI,_flags), m_pPlots(_pBI->GetPlots())
	{}
public:
	virtual bool	__cdecl		LegacyColorValue()const OVERRIDE {return m_LeagacyColorValue;}
private:
	virtual void	__cdecl		ReBindInputs() OVERRIDE { CBaseUserStudyData::ReBindInputs(true); }
};

class CUserSignal :
	public IUserBaseStudy,
	public CBaseUserStudy
{
public:
	explicit CUserSignal(IBaseStudy* _pBI, size_t _flags)
		:	CBaseUserStudy(_pBI,_flags)
	{}
public:
	virtual bool	__cdecl		LegacyColorValue()const OVERRIDE {return m_LeagacyColorValue;}
private:
	virtual void	__cdecl		ReBindInputs() OVERRIDE { CBaseUserStudyData::ReBindInputs(true); }
public:
	class CPortfolioEntriesPriority :
		private _InputValBase<NumSimple>
	{
	public:
		explicit CPortfolioEntriesPriority(IInputsOwner& _master)
			: m_wrap(_master), m_host(_master.get_host())
		{}
	public:
		void	Init(_InputVal<NumSimple>& _expr)
		{
			m_wrap.access_ptr() = &_expr;
			m_host.GetStrategyOrdersGenerator()->SetEntriesPriority(this);
		}
	private:
		virtual _Result	__cdecl	Value(real_t) OVERRIDE { return m_wrap.Value(); }
	private:
		CFuncInputWrap<NumSimple>	m_wrap;
		IBaseStudy&					m_host;
	};
};


#define tool_black			_tool_black()
#define tool_blue			_tool_blue()
#define tool_cyan			_tool_cyan()
#define tool_green			_tool_green()
#define tool_magenta		_tool_magenta()
#define tool_red			_tool_red()
#define tool_yellow			_tool_yellow()
#define tool_white			_tool_white()
#define tool_darkblue		_tool_darkblue()
#define tool_darkcyan		_tool_darkcyan()
#define tool_darkgreen		_tool_darkgreen()
#define tool_darkmagenta	_tool_darkmagenta()
#define tool_darkred		_tool_darkred()
#define tool_darkbrown		_tool_darkbrown()
#define tool_darkgray		_tool_darkgray()
#define tool_lightgray		_tool_lightgray()
#define tool_darkyellow		_tool_darkyellow()

#define black				_black()
#define blue				_blue()
#define cyan				_cyan()
#define green				_green()
#define magenta				_magenta()
#define red					_red()
#define yellow				_yellow()
#define white				_white()
#define darkblue			_darkblue()
#define darkcyan			_darkcyan()
#define darkgreen			_darkgreen()
#define darkmagenta			_darkmagenta()
#define darkred				_darkred()
#define darkbrown			_darkbrown()
#define darkgray			_darkgray()
#define lightgray			_lightgray()
#define darkyellow			_darkyellow()


class CForIncValue
{
public:
	template<class TVar>
	CForIncValue(TVar& _obj, const NumSimple _start, const NumSimple _end)
		: m_obj(_obj.Value()), m_end(_end)
	{
		m_obj=_start;
	}
public:
	operator		bool()const { return NumSimpleLEqual(m_obj, m_end); }
	CForIncValue&	operator ++() {  ++m_obj; return *this; }
private:
	NumSimple&		m_obj;
	const NumSimple	m_end;
};


class CForDecValue
{
public:
	template<class TVar>
	CForDecValue(TVar& _obj, const NumSimple _start, const NumSimple _end)
		: m_obj(_obj.Value()), m_end(_end)
	{
		m_obj=_start;
	}
public:
	operator		bool() const { return NumSimpleGEqual(m_obj, m_end); }
	CForDecValue&	operator --() { --m_obj; return *this; }
private:
	NumSimple&		m_obj;
	const NumSimple	m_end;
};