#pragma once

struct ITWSOrdersManagment
{
	typedef int			TOrderID;
	typedef int			TQuantity;
	typedef size_t		TCount;
	typedef NumSimple	TPrice;

	virtual TOrderID			__cdecl	tws_placebuylimitorder(const char*const symbol, const TQuantity quantity, const TPrice limit_price)=0;
	virtual TOrderID			__cdecl	tws_placebuystoporder(const char*const symbol, const TQuantity quantity, const TPrice stop_price)=0;
	virtual TOrderID			__cdecl	tws_placebuystoplimitorder(const char*const symbol, const TQuantity quantity, const TPrice stop_price, const TPrice limit_price)=0;
	virtual TOrderID			__cdecl	tws_placebuymarketorder(const char*const symbol, const TQuantity quantity)=0;
	
	virtual TOrderID			__cdecl	tws_placeselllimitorder(const char*const symbol, const TQuantity quantity, const TPrice limit_price)=0;
	virtual TOrderID			__cdecl	tws_placesellstoporder(const char*const symbol, const TQuantity quantity, const TPrice stop_price)=0;
	virtual TOrderID			__cdecl	tws_placesellstoplimitorder(const char*const symbol, const TQuantity quantity, const TPrice stop_price, const TPrice limit_price)=0;
	virtual TOrderID			__cdecl	tws_placesellmarketorder(const char*const symbol, const TQuantity quantity)=0;
	
	virtual void				__cdecl	tws_cancelorder(const TOrderID SignalID)=0;
	virtual void				__cdecl	tws_cancelallordersforsymbol(const char*const symbol)=0;
	virtual void				__cdecl	tws_cancelallorder()=0;

	virtual TOrderID			__cdecl	tws_replacewithbuylimitorder(const TOrderID SignalID, const TQuantity quantity, const TPrice limit_price)=0;
	virtual TOrderID			__cdecl	tws_replacewithbuystoporder(const TOrderID SignalID, const TQuantity quantity, const TPrice stop_price)=0;
	virtual TOrderID			__cdecl	tws_replacewithbuystoplimitorder(const TOrderID SignalID, const TQuantity quantity, const TPrice stop_price, const TPrice limit_price)=0;

	virtual TOrderID			__cdecl	tws_replacewithselllimitorder(const TOrderID SignalID, const TQuantity quantity, const TPrice limit_price)=0;
	virtual TOrderID			__cdecl	tws_replacewithsellstoporder(const TOrderID SignalID, const TQuantity quantity, const TPrice stop_price)=0;
	virtual TOrderID			__cdecl	tws_replacewithsellstoplimitorder(const TOrderID SignalID, const TQuantity quantity, const TPrice stop_price, const TPrice limit_price)=0;

	virtual TQuantity			__cdecl	tws_executedportion(const TOrderID OrderID)=0;
	virtual TQuantity			__cdecl	tws_unexecutedportion(const TOrderID OrderID)=0;
	virtual TQuantity			__cdecl	tws_executedtotalpositionforsymbol(const char*const symbol)=0;

	virtual TQuantity			__cdecl	tws_unexecutedbuylimitordersforsymbol(const char*const symbol)=0;
	virtual TQuantity			__cdecl	tws_unexecutedbuystopordersforsymbol(const char*const symbol)=0;

	virtual TQuantity			__cdecl	tws_unexecutedselllimitordersforsymbol(const char*const symbol)=0;
	virtual TQuantity			__cdecl	tws_unexecutedsellstopordersforsymbol(const char*const symbol)=0;

	virtual TCount				__cdecl	tws_numactiveorders()=0;
	virtual const char *		__cdecl	tws_actords_symbol(const TCount OrderIndex)=0;
	virtual TOrderID			__cdecl	tws_actords_orderid(const TCount OrderIndex)=0;
	virtual int					__cdecl	tws_actords_ordertype(const TCount OrderIndex)=0;
	virtual TPrice				__cdecl	tws_actords_stopprice(const TCount OrderIndex)=0;
	virtual TPrice				__cdecl	tws_actords_limitprice(const TCount OrderIndex)=0;
	virtual TQuantity			__cdecl	tws_actords_unexecutedportion(const TCount OrderIndex)=0;

	virtual TCount				__cdecl	tws_numactiveordersforsymbol(const char*const symbol)=0;
	virtual TOrderID			__cdecl	tws_actordsforsymbol_orderid(const char*const symbol, const TCount OrderIndex)=0;
	virtual int					__cdecl	tws_actordsforsymbol_ordertype(const char*const symbol, const TCount OrderIndex)=0;
	virtual TPrice				__cdecl	tws_actordsforsymbol_stopprice(const char*const symbol, const TCount OrderIndex)=0;
	virtual TPrice				__cdecl	tws_actordsforsymbol_limitprice(const char*const symbol, const TCount OrderIndex)=0;
	virtual TQuantity			__cdecl	tws_actordsforsymbol_unexecutedportion(const char*const symbol, const TCount OrderIndex)=0;

	virtual TPrice				__cdecl	tws_getaccountmarketvalue()=0;
	virtual TPrice				__cdecl	tws_getaccountexcessliquidity()=0;
	virtual TPrice				__cdecl	tws_getinitialmargin()=0;
	virtual TPrice				__cdecl	tws_getmaintenancemargin()=0;

	virtual TPrice				__cdecl	tws_getquoteaskforsymbol(const char*const symbol)=0;
	virtual TPrice				__cdecl	tws_getquotebidforsymbol(const char*const symbol)=0;
	virtual TPrice				__cdecl	tws_getquotetradeforsymbol(const char*const symbol)=0;

	virtual int					__cdecl	tws_getconnectionstate()=0;	

	virtual void				__cdecl tws_updatedata()=0;

	virtual	int					__cdecl tws_unexecutedportionforsymbol(const char*const symbol)=0;
	virtual int					__cdecl tws_unexecutedlimitordersforsymbol(const char*const symbol)=0;
	virtual int					__cdecl tws_unexecutedstopordersforsymbol(const char*const symbol)=0;
};