#pragma once

#include "ELRW_BaseTypes.h"

namespace _dummy_ret_vals
{
	template<class _Type, size_t PoolSize>
	class _dummy_ret_vals
	{
	public:
		typedef _Type		value_type;
		typedef	value_type&	reference;
	public:
		_dummy_ret_vals():m_curIndex(0),m_val(){}
	public:
		inline reference	get()
		{
			++m_curIndex;
			if ( m_curIndex >= PoolSize ) { m_curIndex=0; }
			return m_val[m_curIndex];
		}
	protected:
	private:
		size_t		m_curIndex;
		value_type	m_val[PoolSize];
	};
};

template <class TValue>
class Val
{
	TValue m_value;
public:
	typedef TValue	value_type;
public:
	Val(const TValue& val): m_value(val){}
public:
	inline TValue			Value()const{ return m_value; }
	template<typename T> 
	inline TValue			Value(T)const{ return m_value; }
	inline TValue&			ValueEx(){ return m_value; }
public:
	inline operator const TValue&()const{ return m_value; }
};

typedef Val<CountSimple>	CountVal;

template <class TSimple>
struct _InputValBase
{
	typedef	TSimple&				_Result;
	typedef	const TSimple&			_Result_const;
	typedef	TSimple					_Value;

	virtual _Result					__cdecl		Value(real_t=0)=0;

	_Result										ValueExIntrisincs(const real_t _bb) { return this->Value(_bb); }
};

struct _InputValInfo
{
	enum EBindedEntity
	{
		eBE_Expression,
		eBE_Variable,
		eBE_Constant,
	};

	virtual bool					__cdecl		BarPersist()const=0;
	virtual EBindedEntity			__cdecl		GetEntityInfo()const{return eBE_Expression;}
	virtual void					__cdecl		AddBarPersistInfluence(const _InputValInfo*const){}
	virtual void					__cdecl		SetBarPersist(const bool){}
};