#pragma once

#include "ValWrapper.h"
#include "override_h.h"

class IBaseStudy;


namespace _ELAPI_{ namespace variables {
	struct IInitIndexes;
}}

struct IUserStudyVarHost
{
	virtual	void	__cdecl		CloseBarVars(size_t /*_ds*/){}
	virtual	void	__cdecl		RecoveryVars(size_t /*_ds*/){}
	virtual	void	__cdecl		InitializeVars(const _ELAPI_::variables::IInitIndexes& /*_indexes*/){}
};

namespace intrinsic_functions
{
	struct IntrinsicCtx
	{
		virtual const NumSimple&	epsilon()const=0;
		virtual IBaseStudy&			base_study()=0;
	};

	struct IntrinsicFunctionsLife
	{
		virtual	void	__cdecl		destroy_this()=0;
	};

	template<class TSimple>
	struct IntrinsicFunctions : public IntrinsicFunctionsLife {};

	template<>
	struct IntrinsicFunctions<BoolSimple> :
		public IntrinsicFunctionsLife
	{
		virtual NumSimple	__cdecl count_if(IntrinsicCtx& _ctx, const real_t& _from_bb, const real_t& _length)const=0;
	};

	template<>
	struct IntrinsicFunctions<NumSimple> :
		public IntrinsicFunctionsLife
	{
		virtual NumSimple	__cdecl	summ(IntrinsicCtx& _ctx, const real_t& _from_bb, const real_t& _length)const=0;
		virtual void		__cdecl	extremes(IntrinsicCtx& _ctx, const NumSimple& _min_or_max/*-1 - min, 1 - max*/,
											const real_t& _from_bb, const real_t& _length,
											NumSimple& _result, NumSimple& _bb_offset)const=0;
		virtual NumSimple	__cdecl	waverage(IntrinsicCtx& _ctx, const real_t& _from_bb, const real_t& _length)const=0;
		virtual NumSimple	__cdecl	varianceps(IntrinsicCtx& _ctx, const NumSimple& _data_type, const real_t& _from_bb, const real_t& _length)const=0;
		virtual NumSimple	__cdecl	ulcerindex(IntrinsicCtx& _ctx, const real_t& _from_bb, const real_t& _length)const=0;
		virtual NumSimple	__cdecl	summif(IntrinsicCtx& _ctx, _InputValBase<BoolSimple>& _test, const real_t& _from_bb, const real_t& _length)const=0;
		virtual NumSimple	__cdecl	pivot(IntrinsicCtx& _ctx, const real_t& _from_bb, const real_t& _length,
										  const NumSimple& _min_or_max/*-1 - min, 1 - max*/,
										  const NumSimple& _leftstrength, const NumSimple& _rightstrength, const NumSimple& _instance,
										  NumSimple& _oPivotprice, NumSimple& _oPivot_bb_offset)const=0;
		virtual NumSimple	__cdecl	linear_reg(	IntrinsicCtx& _ctx, const real_t& _from_bb, const real_t& _length,
												const NumSimple& _tgt_bar,
												NumSimple& _oLR_Slope, NumSimple& _oLR_Angle,
												NumSimple& _oLR_Intercept, NumSimple& _oLR_Value)const=0;
		virtual NumSimple	__cdecl	std_error(IntrinsicCtx& _ctx, const real_t& _from_bb, const real_t& _length)const=0;
	};
};


template <class TSimple>
struct _InputVal :
	public _InputValBase<TSimple>,
	public _InputValInfo
{
public:
	typedef _InputValInfo::EBindedEntity					EBindedEntity;
	typedef _InputValInfo									EBindedEntityAccessor;

	typedef	typename _InputValBase<TSimple>::_Result		_Result;
	typedef	typename _InputValBase<TSimple>::_Result_const	_Result_const;
	typedef	typename _InputValBase<TSimple>::_Value			_Value;
	typedef	_InputVal<TSimple>								_MyT;
public:
	_InputVal() : m_intrisincs(0) {}
public:
	virtual _MyT&					__cdecl		GetLink(){return *this;}
	virtual _MyT&					__cdecl		GetBindedInput(real_t&){return *this;}
private:
	typedef intrinsic_functions::IntrinsicFunctions<TSimple> TIntrisinc;
public:
	virtual	const TIntrisinc*		__cdecl		GetIntrinsics()const{return m_intrisincs;}
public:
	TIntrisinc*	m_intrisincs;
};

template<class TSimple>
class CDimensionWrap;

template <class TSimple>
struct IArray;

template <class TSimple>
struct _InputVal< IArray<TSimple> > :
	public _InputValBase< IArray<TSimple> >,
	public _InputValInfo
{
	typedef _InputValInfo::EBindedEntity								EBindedEntity;
	typedef _InputValInfo												EBindedEntityAccessor;

	typedef	typename _InputValBase< IArray<TSimple> >::_Result			_Result;
	typedef	typename _InputValBase< IArray<TSimple> >::_Result_const	_Result_const;
	typedef	typename _InputValBase< IArray<TSimple> >::_Value			_Value;
	typedef	_InputVal< IArray<TSimple> >								_MyT;

	virtual _MyT&					__cdecl		GetLink(){return *this;}
	virtual _MyT&					__cdecl		GetBindedInput(real_t&){return *this;}
	virtual CDimensionWrap<TSimple>&__cdecl		GetDimSize(size_t)=0;
};

template <class TSimple>
struct _ArrDef
{
	virtual _InputVal<TSimple>*		__cdecl		init_val()=0;
	virtual size_t					__cdecl		dims_count()const=0;
	virtual const size_t*			__cdecl		dims()const=0;
	virtual const size_t*			__cdecl		fulldims()const=0;
};

template <class TSimple>
struct IArrayInterface
{
	virtual TSimple&				__cdecl		op1	(real_t)=0;
	virtual TSimple&				__cdecl		op2	(real_t,real_t)=0;
	virtual TSimple&				__cdecl		op3	(real_t,real_t,real_t)=0;
	virtual TSimple&				__cdecl		op4	(real_t,real_t,real_t,real_t)=0;
	virtual TSimple&				__cdecl		op5	(real_t,real_t,real_t,real_t,real_t)=0;
	virtual TSimple&				__cdecl		op6	(real_t,real_t,real_t,real_t,real_t,real_t)=0;
	virtual TSimple&				__cdecl		op7	(real_t,real_t,real_t,real_t,real_t,real_t,real_t)=0;
	virtual TSimple&				__cdecl		op8	(real_t,real_t,real_t,real_t,real_t,real_t,real_t,real_t)=0;
	virtual TSimple&				__cdecl		op9	(real_t,real_t,real_t,real_t,real_t,real_t,real_t,real_t,real_t)=0;
	virtual TSimple&				__cdecl		op10(real_t,real_t,real_t,real_t,real_t,real_t,real_t,real_t,real_t,real_t)=0;

	virtual const CountVal&			__cdecl		GetDimSize(size_t)const=0;

	virtual int						__cdecl		Compare(IArray<TSimple>&,const real_t,const real_t,const size_t)=0;
	virtual int						__cdecl		Copy(IArray<TSimple>&,const real_t,const real_t,const size_t)=0;
	virtual int						__cdecl		Type()const=0;
	virtual BoolSimple				__cdecl		Resize(const real_t)=0;
	virtual int						__cdecl		Fill(const real_t,const real_t,const TSimple&)=0;
	virtual int						__cdecl		Sort(const real_t,const real_t,const BoolSimple)=0;
	virtual const NumericSimple		__cdecl		Sum(const real_t,const real_t)=0;
	virtual void					__cdecl		FillEx(const TSimple&)=0;
};

template <class TSimple>
struct IArray
{
protected:
	explicit IArray(IArrayInterface<TSimple>& _impl) : m_impl(_impl) {}
protected:
	~IArray(){}
private:
	IArray(const IArray<TSimple>&);
	IArray<TSimple>& operator=(const IArray<TSimple>&);
public:
	TSimple&				operator()(real_t _1) { return m_impl.op1(_1); }
	TSimple&				operator()(real_t _1,real_t _2) { return m_impl.op2(_1,_2); }
	TSimple&				operator()(real_t _1,real_t _2,real_t _3) { return m_impl.op3(_1,_2,_3); }
	TSimple&				operator()(real_t _1,real_t _2,real_t _3,real_t _4) { return m_impl.op4(_1,_2,_3,_4); }
	TSimple&				operator()(real_t _1,real_t _2,real_t _3,real_t _4,real_t _5) { return m_impl.op5(_1,_2,_3,_4,_5); }
	TSimple&				operator()(real_t _1,real_t _2,real_t _3,real_t _4,real_t _5,real_t _6) { return m_impl.op6(_1,_2,_3,_4,_5,_6); }
	TSimple&				operator()(real_t _1,real_t _2,real_t _3,real_t _4,real_t _5,real_t _6,real_t _7) { return m_impl.op7(_1,_2,_3,_4,_5,_6,_7); }
	TSimple&				operator()(real_t _1,real_t _2,real_t _3,real_t _4,real_t _5,real_t _6,real_t _7,real_t _8) { return m_impl.op8(_1,_2,_3,_4,_5,_6,_7,_8); }
	TSimple&				operator()(real_t _1,real_t _2,real_t _3,real_t _4,real_t _5,real_t _6,real_t _7,real_t _8,real_t _9) { return m_impl.op9(_1,_2,_3,_4,_5,_6,_7,_8,_9); }
	TSimple&				operator()(real_t _1,real_t _2,real_t _3,real_t _4,real_t _5,real_t _6,real_t _7,real_t _8,real_t _9,real_t _10) { return m_impl.op10(_1,_2,_3,_4,_5,_6,_7,_8,_9,_10); }
public:
	const CountVal&			GetDimSize(size_t _idx)const { return m_impl.GetDimSize(_idx); }
public:
	int						Compare(IArray<TSimple>& _obj, const real_t _from, const real_t _to, const size_t _count) { return m_impl.Compare(_obj,_from,_to,_count); }
	int						Copy(IArray<TSimple>& _obj, const real_t _from, const real_t _to, const size_t _count) {
		// Attention! in base interface (IArrayInterface) indexes "from", "to" are in another order
		// http://bugs:8088/browse/MC-6103
		return m_impl.Copy(_obj,_to,_from,_count);
	}
	int						Type()const {return m_impl.Type();}
	BoolSimple				Resize(const real_t _new_size) { return m_impl.Resize(_new_size); }
	int						Fill(const real_t _from, const real_t _to, const TSimple& _val) { return m_impl.Fill(_from,_to,_val); }
	int						Sort(const real_t _from, const real_t _to, const BoolSimple _crit) { return m_impl.Sort(_from,_to,_crit); }
	const NumericSimple		Sum(const real_t _from, const real_t _to) { return m_impl.Sum(_from,_to); }
	void					FillEx(const TSimple& _val) { m_impl.FillEx(_val); }
private:
	IArrayInterface<TSimple>&	m_impl;
};

template <class TSimple>
struct IVariable
{
	typedef TSimple	_MyRetT;

	virtual void					__cdecl		Init(_InputVal<TSimple>&)=0;
	virtual _MyRetT&				__cdecl		Value(real_t=0)=0;
	virtual							__cdecl		operator _InputVal<_MyRetT>&()=0;
	virtual _MyRetT&				__cdecl		ValueEx(const int=0)=0;
};

template <class TSimple>
struct IVariable< IArray<TSimple> >
{
	typedef IArray<TSimple>	_MyRetT;

	virtual void					__cdecl		Init(_ArrDef<TSimple>&)=0;
	virtual _MyRetT&				__cdecl		Value(real_t=0)=0;
	virtual CDimensionWrap<TSimple>&__cdecl		GetDimProxy(size_t)=0;
	virtual							__cdecl		operator _InputVal<_MyRetT>&()=0;
};

template<class TSimple>
class CDimensionWrap
{
public:
	explicit CDimensionWrap(IVariable< IArray<TSimple> >*const _ptr, const size_t _idx)
		:	m_ptr(_ptr),m_idx(_idx)
	{}
public:
	template<class T>
	CountSimple		Value(T) { return m_ptr->Value().GetDimSize(m_idx).Value(); }
	CountSimple		Value() { return m_ptr->Value().GetDimSize(m_idx).Value(); }
private:
	IVariable< IArray<TSimple> >*	m_ptr;
	size_t							m_idx;
};

struct _EntityManage
{
	virtual void					__cdecl		rebind(const bool)=0;
};

struct _VariableManageBase
{
	virtual void 					__cdecl		DelayInitialize()=0;
	// return _InputValBase<T>*
	virtual void* 					__cdecl		GetAsInputValBaseT()=0;
};

struct _InputManage :
	public _EntityManage
{
	virtual void*&					__cdecl		access_ptr()=0;
	virtual _InputValInfo*			__cdecl		get_input()=0;
};

class IBaseStudy;

struct IInputsOwner
{
	virtual	void					__cdecl		push_back(_InputManage*const _input)=0;
	virtual	void					__cdecl		register_g_series(_EntityManage*const _input)=0;
	virtual	void					__cdecl		register_var(_EntityManage*const _input)=0;
	virtual	const bool&				__cdecl		ctx_is_default_prop()const=0;
	virtual	IBaseStudy&				__cdecl		get_host()const=0;
};

template <class TSimple>
struct _MRetVal
{
	virtual TSimple&				__cdecl		Value(real_t=0)=0;

	virtual							__cdecl		operator _InputVal<TSimple>&()=0;

	virtual bool					__cdecl		i_am_running_now(size_t)=0;
	virtual void					__cdecl		delay_init_enviroment(size_t)=0;

	virtual void					__cdecl		set_dn_type(const bool _is_const_or_my_dn)=0;
	virtual void					__cdecl		accept_influence_param(_InputManage*const* _first, const size_t _count)=0;
	virtual bool					__cdecl		is_master_bar_persist()const=0;

	virtual void					__cdecl		close_bar_func(size_t)=0;
	virtual void					__cdecl		recovery_func(size_t)=0;
};

typedef IVariable<NumSimple>	IGlobalVar;